/// @cond EO_CXX_EO_IMPL

inline Elm_Icon_Lookup_Order elm::icon::order_lookup_get() const
{
   Elm_Icon_Lookup_Order _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_icon_order_lookup_get());
   return _tmp_ret;
}

inline void elm::icon::order_lookup_set(Elm_Icon_Lookup_Order order_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_icon_order_lookup_set(order_));
}

inline ::efl::eina::string_view elm::icon::standard_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_icon_standard_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::icon::standard_set(::efl::eina::string_view name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_icon_standard_set(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::icon::thumb_set(::efl::eina::optional< ::efl::eina::string_view > file_, ::efl::eina::optional< ::efl::eina::string_view > group_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_icon_thumb_set(::efl::eolian::to_c(file_), ::efl::eolian::to_c(group_)));
}

inline Elm_Icon_Lookup_Order eo_cxx::elm::icon::order_lookup_get() const
{
   Elm_Icon_Lookup_Order _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_icon_order_lookup_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::icon::order_lookup_set(Elm_Icon_Lookup_Order order_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_icon_order_lookup_set(order_));
}

inline ::efl::eina::string_view eo_cxx::elm::icon::standard_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_icon_standard_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::icon::standard_set(::efl::eina::string_view name_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_icon_standard_set(::efl::eolian::to_c(name_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::icon::thumb_set(::efl::eina::optional< ::efl::eina::string_view > file_, ::efl::eina::optional< ::efl::eina::string_view > group_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_icon_thumb_set(::efl::eolian::to_c(file_), ::efl::eolian::to_c(group_)));
}

inline ::eo_cxx::elm::icon::operator ::elm::icon() const
{
   return *static_cast<::elm::icon const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::icon::operator ::elm::icon&()
{
   return *static_cast<::elm::icon*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::icon::operator ::elm::icon const&() const
{
   return *static_cast<::elm::icon const*>(static_cast<void const*>(this));
}

template <typename T>
Elm_Icon_Lookup_Order elm_icon_order_lookup_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->order_lookup_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Icon_Lookup_Order _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_icon_order_lookup_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Icon_Lookup_Order order_)
{
   try
      {
         static_cast<T*>(self->this_)->order_lookup_set(order_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::string_view elm_icon_standard_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->standard_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_icon_standard_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   try
      {
         return static_cast<T*>(self->this_)->standard_set(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_icon_thumb_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * file_, const char * group_)
{
   try
      {
         static_cast<T*>(self->this_)->thumb_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(file_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(group_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::icon >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::image >::template type<T>
   {
      virtual Elm_Icon_Lookup_Order order_lookup_get()
      {
         Elm_Icon_Lookup_Order _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_icon_order_lookup_get());
            return _tmp_ret;
      }

      virtual void order_lookup_set(Elm_Icon_Lookup_Order order_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_icon_order_lookup_set(order_));
      }

      virtual ::efl::eina::string_view standard_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_icon_standard_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool standard_set(::efl::eina::string_view name_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_icon_standard_set(::efl::eolian::to_c(name_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void thumb_set(::efl::eina::optional< ::efl::eina::string_view > file_, ::efl::eina::optional< ::efl::eina::string_view > group_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_icon_thumb_set(::efl::eolian::to_c(file_), ::efl::eolian::to_c(group_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::icon >
{
   static constexpr int value = 
#if defined(ICON_PROTECTED) && defined(ICON_BETA)
      5
#elif defined(ICON_PROTECTED)
      5
#elif defined(ICON_BETA)
      5
#else
      5
#endif
      + operation_description_class_size<::elm::image >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::icon>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_icon_order_lookup_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_order_lookup_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_icon_order_lookup_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_order_lookup_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_icon_standard_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_standard_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_icon_standard_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_standard_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_icon_thumb_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_thumb_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::image>(), &ops[operation_description_class_size< ::elm::icon >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::icon>)
{
   return (ELM_ICON_CLASS);
}

} } }

/// @endcond

